/*
 * gfuncts.h
 * contains: User include file for Greenleaf Functions 4.01
 *
 * AUTHOR
 *  ""   30-MAR-1987  14:44:05.29
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 * MODIFICATIONS
 *
 */
#define GFVERSION	4		/* Version Number */
#define GFREVISION	01		/* Revision Number */

#ifdef	NARGS
#ifndef	LINT_ARGS
#define	LINT_ARGS	1
#endif
#endif


/*#ifdef	_MSC
#ifndef	_SIZE_T_DEFINED
typedef unsigned int size_t;
#endif
#endif

#ifdef	TURBOC
#ifndef	_SIZE_T
typedef	unsigned size_t;
#endif
#endif

#ifndef	_SIZE_T
#ifndef	_SIZE_T_DEFINED
typedef	unsigned int size_t;
#endif
#endif
*/

#ifndef	GTIMEDATEDOTH
#include "timedate.h"
#endif
#ifndef	DISKDOTH
#include "disk.h"
#endif
#ifndef	GFDOTH
#include "gf.h"
#endif

/* #defines for strconvert()
 */
#define RABLANKS	0x0001	/* Remove all Blanks			  */
#define RANONALPHA	0x0002	/* Remove all non alphabetic characters   */
#define RANONNUM	0x0004	/* Remove all non numeric characters	  */
#define RALEADBLANKS	0x0008	/* Remove all leading blanks		  */
#define RTRBLANKS	0x0010	/* Remove trailing blanks		  */
#define RAALPHA 	0x0020	/* Remove all alphabetic characters	  */
#define RANUMERIC	0x0040	/* Remove all numeric characters	  */
#define RAPUNCT 	0x0080	/* Remove all punctuation		  */
#define CMBTOSINGLE	0x0100	/* Convert multiple blanks to single	  */
#define	CLCTOUPPER	0x0200	/* Convert lower case characters to upper */
#define	CUCTOLOWER	0x0400	/* Convert upper case characters to lower */
#define UCWORDS 	0x0800	/* Capitalize all words 		  */
#define NUCWORDS	0x1000	/* Un-Capitalize all words		  */

/* Error codes returned from some functions.
**
*/
#define GFSUCCESS		  0	 /* Operation successful	    */
#define OPENSOURCEERROR 	 -1	 /* Unable to open source file	    */
#define OPENDESTINATIONERROR	 -2	 /* Unable to open destination file */
#define NOTENOUGHMEMORY 	 -3	 /* Problems allocating memory	    */
#define CANTWRITEDEST		 -4	 /* Problems writing destination    */
#define CANTOPENFILE		 -5	 /* Problems opening file	    */
#define CANTREADFILE		 -6	 /* Problems reading file	    */
#define INVALIDFILE		 -7	 /* Invalid file		    */

/* Error codes returned by print spooler interface functions.
**
*/
#define PSINVALFUNCT		 0x001  /* Invalid function	 */
#define PSFILENOTFOUND		 0x002  /* File not found	 */
#define PSPATHNOTFOUND		 0x003  /* Path not found	 */
#define PSTOOMANYFILES		 0x004  /* Too many open files  */
#define PSACCESSDENIED		 0x005  /* Access denied	 */
#define PSQUEUEFULL		 0x008  /* Print queue is full  */
#define PSBUSY			 0x009  /* Busy		 */
#define PSNAMETOOLONG		 0x00c  /* Name too long	 */
#define PSINVALDRIVE		 0x00f  /* Invalid drive	 */


#define COMPMARK	0x90	/* Special byte that signifies a run
				   sequence and that a count byte follows */

#define SCRNFILID	0x4334	/* Identifies Greenleaf Screen file */

typedef struct {
	int	gffileid;	/* Magic number to identify file    */
	int	gfuversion;	/* Version of Greenleaf Functions   */
	int	gfurevision;	/* Revision of "    "		    */
	int	gfsumcheck;	/* Sum of items 1-3		    */
	int	gfstructsize;	/* Size of structure		    */
	int	gfreadsize;	/* Number of bytes to read screen   */
	int	gfcurrow,	/* Cursor column/row		    */
		gfcurcol,
		gfrows, 	/* Number of rows/columns	    */
		gfcols,
		gfvidmode;	/* Video mode to use		    */

} GFSCRNHDR;

union	GFSCRNFILE {
	GFSCRNHDR f;
	char	gfsfpad[256];
};



#define CancelFile(a)				canfile(a)
#define CancelRedirection(a)			canredir(a)
#define CommitFile(a)				commitfi(a)
#define CreateNewFile(a,b) 			crnfile(a,b)
#define CreateUniqueFile(a,b)			crunfile(a,b)
#define DirectInputToKeyboardBuffer(a)		dinptokb(a)
#define FilesInQueue()				filesinq()
#define GetComputerName(a,b,c)			getmanam(a,b,c)
#define	GetExtDOSError(a,b,c)			dosexter(a,b,c)
#define GetExtMemSize()				getexmem()
#define GetInterruptVector(a)			getivect(a)
#define GetPrinterSetup(a,b,c)			getprsup(a,b,c)
#define GetQueuedFile(a,b)			getqfile(a,b)
#define GetRedirectionEntry(a,b,c,d,e,f)	getreent(a,b,c,d,e,f)
#define	InputToKeyboardBuffer(a)		inptokbb(a)
#define RedirectDevice(a,b,c,d) 		redirdev(a,b,c,d)
#define SetDOSHandleCount(a)			sethncnt(a)
#define SetInterruptVector(a,b) 		setivect(a,b)
#define SetPrinterSetup(a,b,c)			setprsup(a,b,c)
#define SpoolerInstalled()			spoolins()
#define SubmitFile(a)				subfile(a)
#define UnlockFile(a,b,c)			unlkfile(a,b,c)
#define dosxabsread(a,b,c,d)			dosrdabs(a,b,c,d)
#define dosxabswrite(a,b,c,d)			doswrabs(a,b,c,d)

#define gisdigit(x) (((x>='0')&&(x<='9'))?1:0)
#define gisspace(x) (((x==' ')||(x=='\t')||(x=='\n'))?1:0)
#define xmax(a,b) ((int)(a)>(int)(b)?(int)(a):(int)(b))
#define xmin(a,b) ((int)(a)<=(int)(b)?(int)(a):(int)(b))

#ifdef __cplusplus
extern "C" {
#endif

 bool GF_CONV  fexist(char *filename);
 bool GF_CDECL getcarry(void);
 bool GF_CDECL iscolor(void);
 bool GF_CONV  isleap(int);
 bool GF_CONV  isletter(char character);
 bool GF_CDECL ismono(void);
 bool GF_CDECL jprf(int columns,char *format,...);
 bool GF_CONV  jprints(int columns,char *string);
 bool GF_CONV  jprs(int columns,char *string);
 bool GF_CONV  justify(char *dest,char *source,int width);
 bool GF_CDECL rjprintf(int columns,int attribute,int page,char *format,...);
 bool GF_CONV  rjprints(int columns,int attribute,int page,char *string);
 bool GF_CONV  strnull(char *string);
 bool GF_CONV  strtbig(char *string,int maxchars);
 bool GF_CONV  strverify(char *string,char *test,int option);
 
 char* GF_CONV  getcountry(void);
 
 char* GF_CONV  getfield(char *dest,char *source,int width);
 char* GF_CDECL getfname(struct DISKTABLE *diskdata);
 char* GF_CONV  monthname(int month);
 char* GF_CDECL ptrcnv(unsigned segment,unsigned offset);
 char* GF_CONV  sgets(char *dest,char *source,int maxchars);
 char* GF_CONV  strconvert(char *dest,char *source,int option,int maxchars);
 char* GF_CONV  strcreplace(char *dest,char *source,int position,int count,
		 int maxchars);
 char* GF_CONV  strdetab(char *dest,char *source,char *tabs,int defaulttab,
		 int opton,int maxchars);
 char* GF_CONV  strentab(char *dest,char *source,char *tabs,int defaulttab,
		 int option,int maxchars);
 char* GF_CDECL strmake(char *dest,char *source,...);
 char* GF_CONV  strover(char *string,int position);
 char* GF_CONV  strtranslate(char *destination,char *source,char *xlate,
		 char *substitute,int option,int maxchars);
 char* GF_CONV  strxlate(char *dest,char *source,char **xlate,
		 char **substitute,int option,int maxchars);
 char* GF_CONV  strxline(char *dest,char *source,int maxchars);
 char* GF_CONV  wkday(int day);
 char GF_CONV  _gtolower(char character);
 char GF_CONV  _gtoupper(char character);
 char GF_CONV  getdigit(void);
 char GF_CONV  getyn(void);
 int  GF_CONV  FileCopy(char *sourcefile,char *destfile,char *buffer,
		 unsigned int buffersize);
 int GF_CDECL SetDate(int month,int day,int year);
 int GF_CDECL setprsup(int index,int length,char *string);
 int GF_CDECL SetTime(int hour,int minute,int second,int hsec);
 int GF_CONV  _checkstring(char character,char *string,int option);
 int GF_CONV  _gisalpha(char character);
 int GF_CONV  _gisnum(char character);
 int GF_CONV  _gispunct(char character);
 int GF_CONV  _gisspace(char character);
 int GF_CDECL _strcmp(char * *string1,char * *string2);
 int GF_CDECL canfile(char *filename);
 int GF_CDECL canredir(char *devicename);
 int GF_CDECL commitfi(int handle);
 int GF_CONV  compfile(char *infile,char *outfile);
 int GF_CDECL crnfile(unsigned attribute,char *filename);
 int GF_CDECL crunfile(unsigned attribute, char *filename);
 int GF_CONV  curdn(int distance);
 int GF_CDECL curdsk(void);
 int GF_CONV  curlf(int distance);
 int GF_CONV  currt(int distance);
 int GF_CONV  curup(int distance );
 int GF_CONV  datecomp(struct TIMEDATE *date1,struct TIMEDATE *date2,
		 int option);
 int GF_CONV  dayofyr(int month,int day,int year);
 int GF_CONV  dayr(void);
 int GF_CONV  dayweek(int month,int day,int year);
 int GF_CONV  daywk(int year,int month,int day);
 int GF_CDECL dinptokb(unsigned scanchar);
 int GF_CONV  diskstatus(int drive,int option);
 int GF_CDECL dos1read(struct DISKTABLE *diskdata );
 int GF_CDECL dos1write(struct DISKTABLE *diskdata);
 int GF_CDECL dos2close(struct DISKTABLE *diskdata);
 int GF_CDECL dos2create(struct DISKTABLE *diskdata);
 int GF_CDECL dos2open(struct DISKTABLE *diskdata,int mode);
 int GF_CDECL dos2read(struct DISKTABLE *diskdata);
 int GF_CDECL dosabsread(int drive,unsigned sectors,unsigned startsector,
		 char *buffer);
 int GF_CDECL dosabswrite(int drive,unsigned sectors,unsigned startsector,
		 char *buffer);
 int GF_CDECL doschdir(char *directory);
 int GF_CDECL doschmod(struct DISKTABLE *diskdata);
 int GF_CDECL dosexter(int *class,int *action,int *locus);
 int GF_CDECL dosfirst(char *filename,int attribute,char *dest);
 int GF_CDECL dosgetdir(int drive,char *buffer);
 int GF_CDECL dosgetmod(struct DISKTABLE *diskdata);
 int GF_CDECL dosmkdir(char *directory);
 int GF_CDECL dosnext(char *filename,int attribute,char *dest);
 int GF_CDECL dosparse(struct DISKTABLE *diskdata);
 int GF_CDECL dosrdabs(int drive,int sectors,long startsector,void *buffer);
 int GF_CDECL dosrdrblk(struct DISKTABLE *diskdata);
 int GF_CDECL dosrdrrec(struct DISKTABLE *diskdata);
 int GF_CDECL dosrename(char *oldfilename,char *newfilename);
 int GF_CDECL dosrmdir(char *directory);
 int GF_CDECL dossrch(char *searchname,int attribute,char *filename,
		 struct TIMEDATE *filedate,long *filesize,unsigned *fileattr);
 int GF_CDECL doswrabs(int drive,int sectors,long startsector,void *buffer);
 int GF_CDECL doswtrblk(struct DISKTABLE *diskdata);
 int GF_CDECL doswtrrec(struct DISKTABLE *diskdata);
 int GF_CONV  equipment(int option);
 int GF_CONV  expfile(char *infile,char *outfile);
 int GF_CDECL fastdate(struct TIMEDATE *date);
 int GF_CDECL fasttime(struct TIMEDATE *time);
 int GF_CDECL fetchtime(struct TIMEDATE *time);
 int GF_CONV  fgetfield(char *dest,FILE *filestream,int fieldlength);
 int GF_CDECL filesinq(void);
 int GF_CDECL filefind(unsigned attribute,char *pathname,FFFNBUF *buffer);
 int GF_CDECL getfstamp(struct TIMEDATE *timedate,char *filename);
 int GF_CONV  getline(char *dest,int maxchars);
 int GF_CDECL getmanam(char *buffer,int *nameind,int *namenumber);
 int GF_CDECL getprsup(int index, int *maxchars, char *buffer);
 int GF_CDECL getqfile(int index, char *buffer);
 int GF_CDECL getreent(unsigned index,char *localdevname,char *netname,
		 unsigned char *devstatus,unsigned char *devtype,unsigned *hide);
 int GF_CDECL getverify(void);
 int GF_CDECL ggetdta(struct DISKTABLE *diskdata);
 int GF_CDECL inptokbb(unsigned scanchar);
 int GF_CDECL jprintf(int columns,char *format,...);
 int GF_CDECL memsize(void);
 int GF_CONV  prbits(int density,int length,char *buffer);
 int GF_CONV  prfixlf(int increment,int count);
 int GF_CONV  prreset(int printerid);
 int GF_CONV  prsetflen(int option,int linesperpage);
 int GF_CONV  prstatus(int printerid);
 int GF_CONV  prvarlf(int increment,int count);
 int GF_CONV  prx(char character);
 int GF_CDECL putfstamp(struct TIMEDATE *time,char *filename);
 int GF_CONV  recffind(char *path,char *filespec,void (*usrfunc)(char *,char *,struct TIMEDATE *,unsigned char,unsigned long));
 int GF_CDECL redirdev(unsigned devicetype,unsigned callervalue,char *source, 
		 char *dest);
 int GF_CONV  restscrn(char *filename);
 int GF_CONV  savscrn(char *filename);
 int GF_CDECL seldsk(unsigned drive);
 int GF_CDECL sethncnt(int count);
 int GF_CDECL spoolins(void);
 int GF_CONV  strb(char *dest,int position,int count);
 int GF_CONV  strblf(char *dest,int count);
 int GF_CONV  strbrt(char *dest,int count);
 int GF_CONV  strcfind(char *string,char character);
 int GF_CONV  strd(char *string,int position,int count);
 int GF_CONV  strdlf(char *string,int count);
 int GF_CONV  strdrt(char *string,int count);
 int GF_CONV  strfind(char *searchedstring,char *string);
 int GF_CONV  stri(char *dest,char character,int position,int count);
 int GF_CONV  strilf(char *dest,char character,int count);
 int GF_CONV  strirt(char *dest,char character,int count);
 int GF_CONV  strmove(char *dest,char *source);
 int GF_CONV  strpla(char *pointerarray[],char *newpointer);
 int GF_CONV  strplb(char *pointerarray[],char *string,int inum);
 int GF_CONV  strpld(char *pointerarray[],char *deleted);
 int GF_CONV  strpli(char *pointerarray[],int count);
 int GF_CONV  strplrm(char *pointerarray[]);
 int GF_CONV  strplsrt(char *pointerarray[]);
 int GF_CONV  strplsz(char *pointerarray[]);
 int GF_CONV  strr(char *dest,char character,int start,int count);
 int GF_CONV  strrlf(char *dest,char character,int count);
 int GF_CONV  strrrt(char *dest,char character,int count);
 int GF_CONV  strwb(char *dest,int start,int count);
 int GF_CONV  strwblf(char *dest,int count);
 int GF_CONV  strwbrt(char *dest,int count);
 int GF_CONV  strwc(char *string);
 int GF_CONV  strwd(char *dest,int start,int count);
 int GF_CONV  strwdlf(char *dest,int count);
 int GF_CONV  strwdrt(char *dest,int count);
 int GF_CONV  strwi(char *dest,char *source,int count);
 int GF_CONV  strwilf(char *dest,char *source);
 int GF_CONV  strwirt(char *dest,char *source);
 int GF_CONV  strwr(char *dest,char character,int start,int count);
 int GF_CONV  strwrlf(char *dest,char character,int count);
 int GF_CONV  strwrrt(char *dest,char character,int count);
 int GF_CONV  strwx(char *dest,char *source,int start,int count);
 int GF_CONV  strwxlf(char *dest,char *source,int count);
 int GF_CONV  strwxrt(char *dest,char *source,int count);
 int GF_CONV  strx(char *dest,char *source,int start,int count);
 int GF_CONV  strxlf(char *dest,char *source,int count);
 int GF_CONV  strxrt(char *dest,char *source,int count);
 int GF_CDECL subfile(char *filename);
 int GF_CDECL sysint(int intnumber,struct GFREGS *inregs,
		 struct GFREGS *outregs);
 int GF_CDECL vidtype(void);
 long GF_CDECL LockFile(int handle,long offset,long length);
 long GF_CDECL diskfree(int drive,int option);
 long GF_CDECL dos2append(struct DISKTABLE *diskdata);
 long GF_CDECL dosfsize(struct DISKTABLE *diskdata);
 long GF_CDECL dosseek(struct DISKTABLE *diskdata,long offset,int mode);
 long GF_CDECL getlfs(struct DISKTABLE *diskdata);
 long GF_CDECL getrrec(struct DISKTABLE *diskdata);
 long GF_CDECL gfsize(char *filename);
 long GF_CDECL setrrec(struct DISKTABLE *diskdata,long newrecord);
 long GF_CDECL unlkfile(int handle,long offset,long length);
 short GF_CONV gfrand(void);
 short GF_CONV nfrom(short low,short high);
 struct TIMEDATE* GF_CONV fmttime(struct TIMEDATE *timedatadata,int option);
 struct TIMEDATE* GF_CONV ggettime(void);
 struct TIMEDATE* GF_CONV sgettime(int option);
 unsigned GF_CDECL _gcurvpc(void);
 unsigned GF_CDECL _vmode(int videomode);
 unsigned GF_CDECL dos1append(struct DISKTABLE *diskdata);
 unsigned GF_CDECL dos1close(struct DISKTABLE *diskdata);
 unsigned GF_CDECL dos1create(struct DISKTABLE *diskdata);
 unsigned GF_CDECL dos1delete(struct DISKTABLE *diskdata);
 unsigned GF_CDECL dos1open(struct DISKTABLE *diskdata);
 unsigned GF_CDECL dos1rename(struct DISKTABLE *old,struct DISKTABLE *new);
 unsigned GF_CDECL dos2delete(struct DISKTABLE *diskdata);
 unsigned GF_CDECL dos2write(struct DISKTABLE *diskdata);
 unsigned GF_CDECL dosversion(void);
 unsigned GF_CDECL equip(void);
 unsigned GF_CDECL getax(void);
 unsigned GF_CDECL getblk(struct DISKTABLE *diskdata);
 unsigned GF_CDECL getbp(void);
 unsigned GF_CDECL getbx(void);
 unsigned GF_CDECL getcrec(struct DISKTABLE *diskdata);
 unsigned GF_CDECL getcs(void);
 unsigned GF_CDECL getcur(int page);
 unsigned GF_CDECL getcx(void);
 unsigned GF_CDECL getdi(void);
 unsigned GF_CDECL getdot(int row,int column);
 unsigned GF_CDECL getds(void);
 unsigned GF_CDECL getdx(void);
 unsigned GF_CDECL getes(void);
 unsigned GF_CDECL getfattr(struct DISKTABLE *diskdata);
 unsigned GF_CDECL getflags(void);
 unsigned GF_CDECL getlrs(struct DISKTABLE *diskdata);
 unsigned GF_CDECL getsi(void);
 unsigned GF_CDECL getsp(void);
 unsigned GF_CDECL getss(void);
 unsigned GF_CDECL gpeekb(unsigned segment,unsigned offset);
 unsigned GF_CDECL machine(void);
 unsigned GF_CDECL ofsspu(char *pointer);
 unsigned GF_CDECL peekw(unsigned segment,unsigned offset);
 unsigned GF_CDECL rdvch(int page);
 unsigned GF_CDECL segspu(char *pointer);
 unsigned GF_CDECL setblk(struct DISKTABLE *diskdata,unsigned block);
 unsigned GF_CDECL setcrec(struct DISKTABLE *diskdata,unsigned newrecord);
 unsigned GF_CDECL setfattr(struct DISKTABLE *diskdata,unsigned attribute);
 unsigned GF_CDECL setlrs(struct DISKTABLE *diskdata,unsigned recordsize);
 unsigned GF_CDECL fgetchat(int row,int col);
 unsigned GF_CDECL getexmem(void);
 unsigned GF_CDECL vstate(struct GFREGS *output);
 #ifdef _MSC
 void ( GF_CDECL interrupt far *getivect(unsigned) )  ();
 #endif

 #ifdef TURBOC
  void (interrupt far* GF_CDECL getivect(unsigned) ) ();
 #endif

 #ifdef _MSC
 void  GF_CDECL setivect( unsigned, void (GF_CDECL interrupt far *)() );
 #endif

 #ifdef TURBOC
 void GF_CDECL setivect(unsigned,void interrupt (far *)());
 #endif

 void GF_CDECL _cursetc(int row,int col);
 void GF_CDECL _wcvchr(char character,int count);
 void GF_CONV  _xstrncpy(char *source,char *dest,unsigned int option);
 void GF_CONV  atsay(int row,int col,char *string);
 void GF_CDECL border(int color);
 void GF_CONV  centers(char *dest,char *source,int columns);
 void GF_CDECL ceprintf(int columns,char *format,...);
 void GF_CDECL cls(void);
 void GF_CONV  copytime(struct TIMEDATE *dest,struct TIMEDATE *source);
 void GF_CDECL cpch(char character,int foreground,int background,int page);
 void GF_CDECL cprf(int columns,char *format,...);
 void GF_CONV  cprints(int columns,char *string);
 void GF_CONV  cprs(int columns,char *string);
 void GF_CDECL curset(int row,int column,int page);
 void GF_CDECL curtype(int type,int startline,int stopline);
 void GF_CDECL diskreset(void);
 void GF_CDECL dnscroll(int lines,int urow,int lrow,int lcol,int rcol,
		 int attribute);
 void GF_CONV  ebol(void);
 void GF_CONV  ebos(void);
 void GF_CONV  eeol(void);
 void GF_CONV  eeos(void);
 void GF_CDECL egets(char *buffer);
 void GF_CONV  eline(void);
 void GF_CONV  escape(void);
 void GF_CDECL fatwch(int row,int column,int character,
		 unsigned char attribute);
 void GF_CDECL fatwrtf(int row,int column,char *format,...);
 void GF_CDECL fatwstr(int row,int column,char *string);
 void GF_CONV  fcwrts(int columns,char *string);
 void GF_CDECL fillbox(int urow,int lrow,int lcol,int rcol,int attribute);
 void GF_CONV  fjarwrts(int row,int column,int columns,int attribute,
		 char *string);
 void GF_CONV  fjatwrts(int row,int column,int columns,char *string);
 void GF_CDECL font8x8(void);
 void GF_CONV  formfeed(void);
 void GF_CDECL fratwrtf(int row,int column,int attribute,char *format,...);
 void GF_CDECL fratwstr(int row,int column,int attribute,char *string);
 void GF_CONV  frcwrts(int columns,int attribute,char *string);
 void GF_CDECL frwrtf(int attribute,char *format,...);
 void GF_CDECL frwstr(int color,char *string);
 void GF_CDECL fwrtf(char *format,...);
 void GF_CDECL fwstr(char *string);
 void GF_CDECL gcircle(int x,int y,int radius,int color,int aspnumer,
		 int aspdenom);
 void GF_CDECL getscrn(int ulrow,int ulcol,int lrrow,int lrcol,
		 unsigned *buffer);
 void GF_CONV  gfsrand(short initializer);
 void GF_CDECL gline(int x1,int y1,int x2,int y2,int color);
 void GF_CONV  gotodos(void);
 void GF_CDECL gpokeb(unsigned segment,unsigned offset,unsigned value);
 void GF_CDECL gprintf(char *format,...);
 
 void GF_CONV  gputchar(char character,int dum1, int dum2);
 
 void GF_CDECL grprintf(int attribute,char *format,...);
 void GF_CDECL gsetdta(struct DISKTABLE *diskdata);
 void GF_CDECL gsound(int frequency,int duration);
 void GF_CONV  kbflush(void);
 void GF_CONV  napage(int page);
 void GF_CONV  gpaint(int urow,int lcol,int lrow,int rcol,int foreground,
		 int background);
 void GF_CDECL palette(int id,int value);
 void GF_CDECL pch(char character,int attribute,int page);
 void GF_CDECL pokew(unsigned segment,unsigned offset,unsigned value);
 void GF_CONV  prbell(void);
 void GF_CONV  prblanks(int count);
 void GF_CONV  prbold(int option);
 void GF_CONV  prbufclr(void);
 void GF_CONV  prcomp(int option);
 void GF_CONV  prcrlf(void);
 void GF_CONV  prdouble(int option);
 void GF_CONV  premph(int option);
 void GF_CDECL prf(char *format,...);
 void GF_CONV  prfont(int fontselect);
 void GF_CONV  prhome(void);
 void GF_CONV  prhtab(void);
 void GF_CONV  prhtabset(int optoin,int *tabarray);
 
 void GF_CONV prints(char *string);

 void GF_CONV  prmode(int mode);
 void GF_CONV  prnorm(int option);
 void GF_CONV  prputc(char character);
 void GF_CONV  prputcr(void);
 void GF_CONV  prputl(char *string);
 void GF_CONV  prputlf(void);
 void GF_CONV  prs(char *string);
 void GF_CONV  prscreen(void);
 void GF_CONV  prselect(int option);
 void GF_CONV  prsetht(int *tab);
 void GF_CONV  prsetvt(int *tabarray);
 void GF_CONV  prskip(int option,int count);
 void GF_CONV  prstop(int option);
 void GF_CONV  prsub(int option);
 void GF_CONV  prsuper(int option);
 void GF_CONV  prunder(int option);
 void GF_CONV  prunidir(int option);
 void GF_CONV  pruse(int control);
 void GF_CONV  prvtab(void);
 void GF_CONV  prvtabset(int option,int *tabarray);
 void GF_CONV  putcinc(char character,int attribute,int page);
 void GF_CONV  puthexc(char character);
 void GF_CONV  puthexs(char *string);
 void GF_CONV  puthexw(int word);
 void GF_CDECL putscrn(int ulrow,int ulcol,int lrrow,int lrcol,
		 unsigned *buffer);
 void GF_CDECL putverify(int option);
 void GF_CONV  ratsay(int row,int column,int attribute,int page,char *string);
 void GF_CDECL rcprintf(int columns,int attribute,int page,char *format,...);
 void GF_CONV  rcprints(int columns,int attribute,int page,char *string);
 void GF_CDECL readpen(struct GFREGS *output);
 void GF_CDECL rprintf(int attribute,int page,char *format,...);
 void GF_CONV  rprints(int attribute,int page,char *string);
 void GF_CONV  rputcinc(char character,int background,int foreground,
		 int blink,int page);
 void GF_CONV  screen(int mode,int burst,int apage,int vpage);
 void GF_CDECL setfdrvr(int driverid);
 void GF_CDECL setmaxx(int maxx);
 void GF_CDECL setmaxy(int maxy);
 void GF_CDECL stackdump(int count,...);
 void GF_CDECL timer(unsigned count);
 void GF_CDECL tocolor(void);
 void GF_CDECL tomono(void);
 void GF_CDECL upscroll(int lines,int urrow,int lrow,int lcol,int rcol,
		 int attribute);
 void GF_CONV  vmode(int mode);
 void GF_CDECL vpage(int page);
 void GF_CDECL wtdot(int row,int column,int color);
 void GF_CDECL wttty(char character,int attribute);
 void GF_CDECL wtvch(char character,int attribute,int page,int count);
 void GF_CDECL wtvchar(char character,int page,int count);
 void GF_CDECL _disenk(void);

#ifdef __cplusplus
}
#endif
 
#ifndef	GFGLOBALFILE
 extern int gmaxcol,gmaxrow,gmaxpcol,gjwidth,gtabexp,_gfvers,_gfrev,_gvmtrp;
 extern char gteol;
 extern char _gfspbuf[];
 extern unsigned _gferror;
#endif
